searchNodes=[{"doc":"A library allowing calculations with colors and conversions between different colorspaces.","ref":"Tint.html","title":"Tint","type":"module"},{"doc":"Converts the given color to another colorspace.Examplesiex&gt; Tint.convert(Tint.RGB.new(40, 66, 67), :cmyk) {:ok, %Tint.CMYK{cyan: 0.403, magenta: 0.0149, yellow: 0.0, key: 0.7373}} iex&gt; Tint.convert(Tint.RGB.new(255, 127, 30), Tint.HSV) {:ok, %Tint.HSV{hue: 25.9, saturation: 0.8824, value: 1.0}} iex&gt; Tint.convert(Tint.RGB.new(255, 127, 30), :invalid) :error","ref":"Tint.html#convert/2","title":"Tint.convert/2","type":"function"},{"doc":"Converts the given color to another colorspace. Raises when the colorspace is invalid.Examplesiex&gt; Tint.convert!(Tint.RGB.new(40, 66, 67), :cmyk) %Tint.CMYK{cyan: 0.403, magenta: 0.0149, yellow: 0.0, key: 0.7373} iex&gt; Tint.convert!(Tint.RGB.new(255, 127, 30), Tint.HSV) %Tint.HSV{hue: 25.9, saturation: 0.8824, value: 1.0} iex&gt; Tint.convert!(Tint.RGB.new(255, 127, 30), :foo) ** (ArgumentError) Unknown colorspace: :foo","ref":"Tint.html#convert!/2","title":"Tint.convert!/2","type":"function"},{"doc":"Gets the converted module for the given colorspace atom or module.","ref":"Tint.html#converter_for/1","title":"Tint.converter_for/1","type":"function"},{"doc":"Converts the given color to the CMYK colorspace.Exampleiex&gt; Tint.to_cmyk(Tint.RGB.new(40, 66, 67)) #Tint.CMYK&lt;40.3%,1.49%,0.0%,73.73%&gt;","ref":"Tint.html#to_cmyk/1","title":"Tint.to_cmyk/1","type":"function"},{"doc":"Converts the given color to the DIN99 colorspace.","ref":"Tint.html#to_din99/1","title":"Tint.to_din99/1","type":"function"},{"doc":"Converts the given color to the HSV colorspace.Exampleiex&gt; Tint.to_hsv(Tint.RGB.new(255, 127, 30)) #Tint.HSV&lt;25.9°,88.24%,100.0%&gt;","ref":"Tint.html#to_hsv/1","title":"Tint.to_hsv/1","type":"function"},{"doc":"Converts the given color to the CIELAB colorspace.","ref":"Tint.html#to_lab/1","title":"Tint.to_lab/1","type":"function"},{"doc":"Converts the given color to the RGB colorspace.Exampleiex&gt; Tint.to_rgb(Tint.HSV.new(25.8, 0.882, 1)) #Tint.RGB&lt;255,127,30 (#FF7F1E)&gt;","ref":"Tint.html#to_rgb/1","title":"Tint.to_rgb/1","type":"function"},{"doc":"Converts the given color to the XYZ (CIE 1931) colorspace.","ref":"Tint.html#to_xyz/1","title":"Tint.to_xyz/1","type":"function"},{"doc":"A type representing a color.","ref":"Tint.html#t:color/0","title":"Tint.color/0","type":"type"},{"doc":"A type representing a colorspace.","ref":"Tint.html#t:colorspace/0","title":"Tint.colorspace/0","type":"type"},{"doc":"A module providing a sigil to build colors.","ref":"Tint.Sigil.html","title":"Tint.Sigil","type":"module"},{"doc":"A sigil to build a color.The sigil identifier is K (try using &quot;kolor&quot; as mnemonic) because C is already taken by the built-in charlist sigil.ExamplesFirst you need to import this particular module.import Tint.SigilYou can build a RGB color using a hex code, just like Tint.RGB.from_hex/1 does:iex&gt; ~K[#FFCC00] #Tint.RGB&lt;255,204,0 (#FFCC00)&gt;Or using the red, green and blue components using the r modifier.iex&gt; ~K[255,204,0]r #Tint.RGB&lt;255,204,0 (#FFCC00)&gt;HSV colors are also supported using the h modifier.iex&gt; ~K[48,1,1]h #Tint.HSV&lt;48.0°,100.0%,100.0%&gt;CMYK colors are supported using the c modifier.iex&gt; ~K[0.06, 0.32, 0.8846, 0.23]c #Tint.CMYK&lt;6.0%,32.0%,88.46%,23.0%&gt;CIELAB colors are supported using the l modifier.iex&gt; ~K[50.1234,10.7643,10.4322]l #Tint.Lab&lt;50.1234,10.7643,10.4322&gt;DIN99 colors are supported using the d modifier.iex&gt; ~K[50.1234,10.7643,10.4322]d #Tint.DIN99&lt;50.1234,10.7643,10.4322&gt;XYZ colors are supported using the x modifier.iex&gt; ~K[50.9505,1,1.09]x #Tint.XYZ&lt;50.9505,1.0,1.09&gt;","ref":"Tint.Sigil.html#sigil_K/2","title":"Tint.Sigil.sigil_K/2","type":"function"},{"doc":"A color in the CMYK (cyan, magenta, yellow, key) colorspace.","ref":"Tint.CMYK.html","title":"Tint.CMYK","type":"module"},{"doc":"Converts a tuple containing cyan, magenta, yellow and key color parts into a Tint.CMYK struct.","ref":"Tint.CMYK.html#from_tuple/1","title":"Tint.CMYK.from_tuple/1","type":"function"},{"doc":"Builds a new CMYK color from cyan, magenta, yellow and key color parts. Please always use this function to build a new CMYK color.Examplesiex&gt; Tint.CMYK.new(0.06, 0.32, 0.8846, 0.23) #Tint.CMYK&lt;6.0%,32.0%,88.46%,23.0%&gt; iex&gt; Tint.CMYK.new(0.06, 3.2, 0.8846, 0.23) ** (Tint.OutOfRangeError) Value 3.2 is out of range [0,1]","ref":"Tint.CMYK.html#new/4","title":"Tint.CMYK.new/4","type":"function"},{"doc":"Converts CMYK color into a tuple containing the cyan, magenta, yellow and key parts.","ref":"Tint.CMYK.html#to_tuple/1","title":"Tint.CMYK.to_tuple/1","type":"function"},{"doc":"","ref":"Tint.CMYK.html#t:t/0","title":"Tint.CMYK.t/0","type":"type"},{"doc":"A color in the DIN99 colorspace.","ref":"Tint.DIN99.html","title":"Tint.DIN99","type":"module"},{"doc":"Converts a tuple containing lightness, a and b into Tint.DIN99 struct.","ref":"Tint.DIN99.html#from_tuple/1","title":"Tint.DIN99.from_tuple/1","type":"function"},{"doc":"Builds a new DIN99 color using the lightness, a and b color channels.","ref":"Tint.DIN99.html#new/3","title":"Tint.DIN99.new/3","type":"function"},{"doc":"Converts a DIN99 color into a tuple containing the lightness, a and b channels.","ref":"Tint.DIN99.html#to_tuple/1","title":"Tint.DIN99.to_tuple/1","type":"function"},{"doc":"","ref":"Tint.DIN99.html#t:t/0","title":"Tint.DIN99.t/0","type":"type"},{"doc":"A color in the HSV (hue, saturation, value) colorspace.","ref":"Tint.HSV.html","title":"Tint.HSV","type":"module"},{"doc":"Converts a tuple containing hue, saturation and value into a Tint.HSV struct.","ref":"Tint.HSV.html#from_tuple/1","title":"Tint.HSV.from_tuple/1","type":"function"},{"doc":"Determines whether the given color is a grayscale color which basically means that saturation or the value is 0.","ref":"Tint.HSV.html#grayscale?/1","title":"Tint.HSV.grayscale?/1","type":"function"},{"doc":"Checks whether the hue of the given color is in the specified bounds. This can be used to cluster colors by their chromaticity.","ref":"Tint.HSV.html#hue_between?/3","title":"Tint.HSV.hue_between?/3","type":"function"},{"doc":"Builds a new HSV color from hue, saturation and value color parts. Please always use this function to build a new HSV color.Examplesiex&gt; Tint.HSV.new(25.8, 0.882, 1) #Tint.HSV&lt;25.8°,88.2%,100%&gt;","ref":"Tint.HSV.html#new/3","title":"Tint.HSV.new/3","type":"function"},{"doc":"Converts HSV color into a tuple containing the hue, saturation and value parts.","ref":"Tint.HSV.html#to_tuple/1","title":"Tint.HSV.to_tuple/1","type":"function"},{"doc":"","ref":"Tint.HSV.html#t:t/0","title":"Tint.HSV.t/0","type":"type"},{"doc":"A color in the CIELAB colorspace.","ref":"Tint.Lab.html","title":"Tint.Lab","type":"module"},{"doc":"Calculates the distance of two colors using the CIEDE2000 algorithm. See Tint.Distance.CIEDE2000 for more details.","ref":"Tint.Lab.html#ciede2000_distance/3","title":"Tint.Lab.ciede2000_distance/3","type":"function"},{"doc":"Converts a tuple containing lightness, a and b into Tint.Lab struct.","ref":"Tint.Lab.html#from_tuple/1","title":"Tint.Lab.from_tuple/1","type":"function"},{"doc":"Gets the nearest color from the given palette using the CIEDE2000 color distance algorithm.Options:weights - A tuple defining the weights for the LCh color channels. Defaults to {1, 1, 1}.","ref":"Tint.Lab.html#nearest_color/3","title":"Tint.Lab.nearest_color/3","type":"function"},{"doc":"Gets the n nearest colors from the given palette using the CIEDE2000 color distance algorithm.","ref":"Tint.Lab.html#nearest_colors/4","title":"Tint.Lab.nearest_colors/4","type":"function"},{"doc":"Builds a new Lab color using the lightness, a and b color channels.","ref":"Tint.Lab.html#new/3","title":"Tint.Lab.new/3","type":"function"},{"doc":"Converts a Lab color into a tuple containing the lightness, a and b channels.","ref":"Tint.Lab.html#to_tuple/1","title":"Tint.Lab.to_tuple/1","type":"function"},{"doc":"","ref":"Tint.Lab.html#t:t/0","title":"Tint.Lab.t/0","type":"type"},{"doc":"A color in the RGB (red, green, blue) colorspace.","ref":"Tint.RGB.html","title":"Tint.RGB","type":"module"},{"doc":"Calculates the complementary of the given RGB color.Exampleiex&gt; Tint.RGB.complementary_color(%Tint.RGB{red: 255, green: 0, blue: 0}) #Tint.RGB&lt;0,255,255 (#00FFFF)&gt;","ref":"Tint.RGB.html#complementary_color/1","title":"Tint.RGB.complementary_color/1","type":"function"},{"doc":"Calculates the Euclidean distance of two colors.Options:weights - A tuple defining the weights for the red, green and blue color channels. Defaults to {1, 1, 1}.","ref":"Tint.RGB.html#euclidean_distance/3","title":"Tint.RGB.euclidean_distance/3","type":"function"},{"doc":"Builds a new RGB color from the given hex code.Examplesiex&gt; Tint.RGB.from_hex(&quot;#FF7F1E&quot;) {:ok, %Tint.RGB{red: 255, green: 127, blue: 30}} iex&gt; Tint.RGB.from_hex(&quot;F00&quot;) {:ok, %Tint.RGB{red: 255, green: 0, blue: 0}} iex&gt; Tint.RGB.from_hex(&quot;invalid&quot;) :error","ref":"Tint.RGB.html#from_hex/1","title":"Tint.RGB.from_hex/1","type":"function"},{"doc":"Builds a new RGB color from the given hex code. Raises when the given hex code is invalid.Examplesiex&gt; Tint.RGB.from_hex!(&quot;#FF7F1E&quot;) #Tint.RGB&lt;255,127,30 (#FF7F1E)&gt; iex&gt; Tint.RGB.from_hex!(&quot;invalid&quot;) ** (ArgumentError) Invalid hex code: invalid","ref":"Tint.RGB.html#from_hex!/1","title":"Tint.RGB.from_hex!/1","type":"function"},{"doc":"Builds a new RGB color from red, green and blue color ratios.Exampleiex&gt; Tint.RGB.from_ratios(1, 0.5, 0) #Tint.RGB&lt;255,128,0 (#FF8000)&gt;","ref":"Tint.RGB.html#from_ratios/3","title":"Tint.RGB.from_ratios/3","type":"function"},{"doc":"Converts a tuple containing hue, saturation and value into a Tint.RGB struct.Exampleiex&gt; Tint.RGB.from_tuple({255, 127, 30}) #Tint.RGB&lt;255,127,30 (#FF7F1E)&gt;","ref":"Tint.RGB.html#from_tuple/1","title":"Tint.RGB.from_tuple/1","type":"function"},{"doc":"Determines whether the given color is grayish based on the distance of the red, green an blue channels of the color.Additionally, you have to specify a tolerance that defines how far the min and the max channels may be apart from each other. A tolerance of 0 means that the color has to be an exact grayscale color. A tolerance of 255 means that any color is regarded gray.","ref":"Tint.RGB.html#grayish?/2","title":"Tint.RGB.grayish?/2","type":"function"},{"doc":"Determines whether the given color is a grayscale color which basically means that the red, green and blue channels of the color have the same value.","ref":"Tint.RGB.html#grayscale?/1","title":"Tint.RGB.grayscale?/1","type":"function"},{"doc":"Finds the nearest color for the specified color using the given color palette and an optional distance algorithm.","ref":"Tint.RGB.html#nearest_color/3","title":"Tint.RGB.nearest_color/3","type":"function"},{"doc":"Finds the n nearest colors for the specified color using the given color palette and an optional distance algorithm.","ref":"Tint.RGB.html#nearest_colors/4","title":"Tint.RGB.nearest_colors/4","type":"function"},{"doc":"Builds a new RGB color from red, green and blue color parts. Please always use this function to build a new RGB color.Examplesiex&gt; Tint.RGB.new(0, 0, 0) #Tint.RGB&lt;0,0,0 (#000000)&gt; iex&gt; Tint.RGB.new(255, 127, 30) #Tint.RGB&lt;255,127,30 (#FF7F1E)&gt; iex&gt; Tint.RGB.new(256, -1, 0) ** (Tint.OutOfRangeError) Value 256 is out of range [0,255]","ref":"Tint.RGB.html#new/3","title":"Tint.RGB.new/3","type":"function"},{"doc":"Converts a RGB color to a hex code.Exampleiex&gt; Tint.RGB.to_hex(%Tint.RGB{red: 255, green: 127, blue: 30}) &quot;#FF7F1E&quot;","ref":"Tint.RGB.html#to_hex/1","title":"Tint.RGB.to_hex/1","type":"function"},{"doc":"Builds a tuple containing the ratios of the red, green and blue components of a given color.","ref":"Tint.RGB.html#to_ratios/1","title":"Tint.RGB.to_ratios/1","type":"function"},{"doc":"Converts a RGB color into a tuple containing the red, green and blue channels.Exampleiex&gt; Tint.RGB.to_tuple(%Tint.RGB{red: 255, green: 127, blue: 30}) {255, 127, 30}","ref":"Tint.RGB.html#to_tuple/1","title":"Tint.RGB.to_tuple/1","type":"function"},{"doc":"","ref":"Tint.RGB.html#t:t/0","title":"Tint.RGB.t/0","type":"type"},{"doc":"A color in the XYZ (CIE 1931) colorspace.","ref":"Tint.XYZ.html","title":"Tint.XYZ","type":"module"},{"doc":"Builds a new XYZ color using the lightness, a and b color channels.","ref":"Tint.XYZ.html#new/3","title":"Tint.XYZ.new/3","type":"function"},{"doc":"","ref":"Tint.XYZ.html#t:t/0","title":"Tint.XYZ.t/0","type":"type"},{"doc":"A module providing functions for color distance calculations and a behavior to implement custom distance algorithms.","ref":"Tint.Distance.html","title":"Tint.Distance","type":"behaviour"},{"doc":"Calculate the distance of two colors using the given distance algorithm.","ref":"Tint.Distance.html#distance/3","title":"Tint.Distance.distance/3","type":"function"},{"doc":"Calculate the distance of two colors using the given options.","ref":"Tint.Distance.html#c:distance/3","title":"Tint.Distance.distance/3","type":"callback"},{"doc":"Gets the nearest color from the specified palette using the given distance algorithm.","ref":"Tint.Distance.html#nearest_color/3","title":"Tint.Distance.nearest_color/3","type":"function"},{"doc":"Gets the nearest n colors from the specified palette using the given distance algorithm.","ref":"Tint.Distance.html#nearest_colors/4","title":"Tint.Distance.nearest_colors/4","type":"function"},{"doc":"A distance calculation module that implements this very behavior or a function that allows calculating the distance between two colors.","ref":"Tint.Distance.html#t:distance_algorithm/0","title":"Tint.Distance.distance_algorithm/0","type":"type"},{"doc":"A function that allows calculating the distance between two colors.","ref":"Tint.Distance.html#t:distance_fun/0","title":"Tint.Distance.distance_fun/0","type":"type"},{"doc":"A module that implements the CIEDE2000 color distance algorithm. (http://www2.ece.rochester.edu/~gsharma/ciede2000/ciede2000noteCRNA.pdf)","ref":"Tint.Distance.CIEDE2000.html","title":"Tint.Distance.CIEDE2000","type":"module"},{"doc":"A module that implements the Euclidean distance algorithm for RGB colors. (https://en.wikipedia.org/wiki/Color_difference#Euclidean)","ref":"Tint.Distance.Euclidean.html","title":"Tint.Distance.Euclidean","type":"module"},{"doc":"An exception that is returned or raised when a color is built with values that are out of the permitted range of values.","ref":"Tint.OutOfRangeError.html","title":"Tint.OutOfRangeError","type":"exception"},{"doc":"","ref":"Tint.OutOfRangeError.html#t:t/0","title":"Tint.OutOfRangeError.t/0","type":"type"},{"doc":"Tint An Elixir library allowing calculations with colors and conversions between different colorspaces.Currently supports the following color models:RGBCMYKHSVL*a*b* (CIELAB)XYZ (CIE 1931)DIN99","ref":"readme.html","title":"Tint","type":"extras"},{"doc":"Elixir 1.8 or greater","ref":"readme.html#prerequisites","title":"Tint - Prerequisites","type":"extras"},{"doc":"The package can be installed by adding tint to your list of dependencies in mix.exs:def deps do [ {:tint, &quot;~&gt; 1.1&quot;} ] end","ref":"readme.html#installation","title":"Tint - Installation","type":"extras"},{"doc":"ColorspacesRGBiex&gt; Tint.RGB.new(255, 0, 0) #Tint.RGB&lt;255,0,0 (#FF0000)&gt;oriex&gt; import Tint.Sigil ...&gt; ~K[255, 0, 0]r #Tint.RGB&lt;255,0,0 (#FF0000)&gt;Using hex codes:iex&gt; Tint.RGB.from_hex(&quot;#FF0000&quot;) {:ok, #Tint.RGB&lt;255,0,0 (#FF0000)&gt;} iex&gt; Tint.RGB.from_hex(&quot;#F00&quot;) {:ok, #Tint.RGB&lt;255,0,0 (#FF0000)&gt;} iex&gt; Tint.RGB.from_hex(&quot;FF0000&quot;) {:ok, #Tint.RGB&lt;255,0,0 (#FF0000)&gt;} iex&gt; Tint.RGB.from_hex!(&quot;F00&quot;) #Tint.RGB&lt;255,0,0 (#FF0000)&gt; iex&gt; Tint.RGB.from_hex(&quot;invalid&quot;) :error iex&gt; Tint.RGB.from_hex!(&quot;invalid&quot;) ** (ArgumentError) Invalid hex code: invalidoriex&gt; import Tint.Sigil ...&gt; ~K[#FF0000] #Tint.RGB&lt;255,0,0 (#FF0000)&gt;To convert RGB colors back to hex codes:iex&gt; color = Tint.RGB.new(255, 0, 0) ...&gt; Tint.RGB.to_hex(color) &quot;#FF0000&quot;CMYKiex&gt; Tint.CMYK.new(0.55, 0.26, 0.24, 0.65) #Tint.CMYK&lt;55%,26%,24%,65%&gt;oriex&gt; import Tint.Sigil ...&gt; ~K[0.55, 0.26, 0.24, 0.65]c #Tint.CMYK&lt;55%,26%,24%,65%&gt;HSViex&gt; Tint.HSV.new(25.8, 0.882, 1) #Tint.HSV&lt;25.8°,88.2%,100%&gt;oriex&gt; import Tint.Sigil ...&gt; ~K[25.8, 0.882, 1]h #Tint.HSV&lt;25.8°,88.2%,100%&gt;CIELABiex&gt; Tint.Lab.new(53.2329, 80.1068, 67.2202) #Tint.Lab&lt;53.2329,80.1068,67.2202&gt;oriex&gt; import Tint.Sigil ...&gt; ~K[53.2329, 80.1068, 67.2202]c #Tint.Lab&lt;53.2329,80.1068,67.2202&gt;DIN99iex&gt; Tint.DIN99.new(53.2329, 80.1068, 67.2202) #Tint.DIN99&lt;53.2329,80.1068,67.2202&gt;oriex&gt; import Tint.Sigil ...&gt; ~K[53.2329, 80.1068, 67.2202]d #Tint.DIN99&lt;53.2329,80.1068,67.2202&gt;Conversioniex&gt; rgb = Tint.RGB.new(255, 0, 0) ...&gt; Tint.to_hsv(rgb) #Tint.HSV&lt;0°,100%,100%&gt;The complete list:Tint.to_cmyk(color) Tint.to_din99(color) Tint.to_hsv(color) Tint.to_lab(color) Tint.to_rgb(color) Tint.to_xyz(color)Alternatively you can use convert/2 and convert!/2:Tint.convert(color, :rgb) Tint.convert(color, Tint.RGB) Tint.convert!(color, :hsv)Currently, only RGB can be converted to any other colorspace.Color DistanceThere are a couple of functions to calculate the distance between two colors.Euclidean DistanceThe Euclidean distance can be calculated on RGB colors. Calculating the Euclidean distance is very fast but may not be very precise. If you want maximum precision use the CIEDE2000 algorithm.iex&gt; Tint.RGB.euclidean_distance(~K[#FFFFFF], ~K[#000000]) 441.6729559300637You can also define weights for the individual red, green and blue color channels:iex&gt; Tint.RGB.euclidean_distance(~K[#FFFFFF], ~K[#000000], weights: {2, 4, 3}) 765.0To find the nearest color from a given palette:iex&gt; Tint.RGB.nearest_color(~K[#CC0000], [~K[#009900], ~K[#FF0000]]) #Tint.RGB&lt;255,0,0 (#FF0000)&gt;CIEDE2000CIEDE2000 is an algorithm that operates on the CIELAB colorspace. It is very slow compared to the Euclidean distance algorithm but it is optimized to human color perception.iex&gt; Tint.Lab.ciede2000_distance(~K[#FF0000], ~K[#000000]) 50.3905024704449To find the nearest color from a given palette:iex&gt; Tint.Lab.nearest_color(~K[#FF0000], [~K[#009900], ~K[#CC0000]]) #Tint.RGB&lt;204,0,0 (#CC0000)&gt;Complementary Coloriex&gt; Tint.RGB.complementary_color(~K[#FF0000]) #Tint.RGB&lt;0,255,255 (#00FFFF)&gt;","ref":"readme.html#usage","title":"Tint - Usage","type":"extras"},{"doc":"The API docs can be found at HexDocs.","ref":"readme.html#docs","title":"Tint - Docs","type":"extras"}]